#!/usr/bin/python
# -*- coding: utf-8 -*- 
#
#  @Copyright (C) 2008 Kim Jin Chul (shriekout@gmail.com).
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Library General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

API_KEY = 'b01b9e7d6dda15d2be19197723184e6a'

def queryEngDic(word):
	if not word: return None

	queryUrl = 'http://openapi.naver.com/search?key=%s'\
		'&query=%s&display=5&start=1&target=endic'\
		%(API_KEY, word)
	try:
		return readHTMLSource(queryUrl)
	except:
		return None

def readHTMLSource(url, coding = 'utf-8'):
	import urllib2

	socket = urllib2.urlopen(url)
	htmlSource = socket.read()
	socket.close()

	return unicode(htmlSource, coding).encode('utf-8')

def parsingXMLSource(xmlSource):
	if not xmlSource: return None

	import xml.etree.ElementTree as ET

	ndicResult = ET.XML(xmlSource)
	if ndicResult.tag == 'rss':
		ndicChann = ndicResult[0] #ndicResult.find('channel')
		ndicItems = (i for i in ndicChann if i.tag=="item")
		ndicLinks = map(lambda x: x.find('link').text, ndicItems)
		return ndicLinks
	elif ndicResult.tag == '{naver:openapi}error':
		print ndicResult.text
		print "%s: %s"%(
			ndicResult.find('{naver:openapi}error_code').text, 
			ndicResult.find('{naver:openapi}message').text)
	else:
		print "검색 결과를 찾을 수 없습니다."

	return None

def parsingHTML(source):
	import re

	p = re.compile('http://.*mp3')
	try:
		voice = p.findall(source)[0]
	except:
		voice = ''

	p = re.compile('<div id="entryBody333" style="display: none;">((.|\n)*)<!-- //뜻풀이-->')
	source = p.split(source)

	p = re.compile('<br>', re.IGNORECASE)
	source = p.sub('\n', source[1])

	source = source.replace('&nbsp;', '')

	p = re.compile('<(/)?([a-zA-Z]*)(\\s[a-zA-Z]*=[^>]*)?(\\s)*(/)?>')
	source = p.sub('', source)	

	p = re.compile('<!--(([^-]*)|([-]{2})([^>]{1}))-->')
	source = p.sub('', source)

	source = source.strip()

	return voice + '\n' + source

if __name__ == '__main__':
	import sys

	if len(sys.argv) != 2:
		print 'Usage : ndic_sh word'
		sys.exit(1)

	result = queryEngDic(sys.argv[1])
	result = parsingXMLSource(result)

	if not result:
		sys.exit(1)

	itemCnt = len(result)
	print itemCnt

	currCnt = 0
	for itemAddr in result:
		content = readHTMLSource(itemAddr, 'euc-kr')
		content = parsingHTML(content)
		print content
		print '출처 : naver.com (%s)'%itemAddr
		
		currCnt += 1
		if not currCnt == itemCnt:
			print '------------------------------'
